; ////////////////////////////////////////
; // Ms. Smac-Man
; // by Eikon
; //
; // Eiksoft.com
; ////////////////////////////////////////
AppTitle "Ms. Smac-Man"
Graphics 512, 640, 16, 2
Graphics 256, 320, 16, 3
SetBuffer BackBuffer()
SeedRnd MilliSecs()

Global imgMaze = LoadAnimImage("work.png", 234, 302, 0, 2)
Global imgDot = LoadAnimImage("dot.png", 8, 8, 0, 2)
Global imgPac = LoadAnimImage("pac.png", 16, 16, 0, 16)
Global imgFruit = LoadAnimImage("fruit.png", 14, 14, 0, 7)
Global imgGhost = LoadAnimImage("ghost.png", 14, 13, 0, 12)

MaskImage imgMaze, 255, 0, 255

Type Obj
	Field X#, Y#, ID, D, C, I#, A, T, F, Col[4], R#
End Type

Global sfxWakka = LoadSound("wakka.wav")
Global sfxDeath = LoadSound("death.wav")
Global sfxStart = LoadSound("start.wav")
Global sfxEat = LoadSound("eat.wav")
Global sfxSuper = LoadSound("super.wav")

Global sfxChan

Global Font = LoadFont("Verdana", 16, True, 0, 0)
Global Font2 = LoadFont("Verdana", 12, True, 0, 0)
SetFont Font

Global pScore, pLives, bSfx = True

.StartOver
bCheat = False
bFresh = True
FlushKeys

Delete Each Obj

tmpX = -120
tmpF = 0
tmpT = MilliSecs()
tmpF2 = 0
tmpT2 = MilliSecs()

; Title
Repeat

DrawImage imgPac, tmpX, 158, tmpF
DrawImage imgGhost, tmpX + 40, 160, tmpF2
DrawImage imgGhost, tmpX + 60, 160, tmpF2 + 2
DrawImage imgGhost, tmpX + 80, 160, tmpF2 + 4
DrawImage imgGhost, tmpX + 100, 160, tmpF2 + 6

If tmpX < 320 Then tmpX = tmpX + 1 Else tmpX = -120

If MilliSecs() >= tmpT + 75 Then
	If tmpF < 3 Then tmpF = tmpF + 1 Else tmpF = 0
	
	tmpT = MilliSecs()
EndIf

If MilliSecs() >= tmpT2 + 120 Then
	If tmpF2 < 1 Then tmpF2 = tmpF2 + 1 Else tmpF2 = 0
	
	tmpT2 = MilliSecs()
EndIf

Text 128 - (StringWidth("MS. SMAC-MAN") / 2), 100, "MS. SMAC-MAN"
Text 128 - (StringWidth("by Eiksoft") / 2), 126, "by Eiksoft"

Text 128 - (StringWidth("Press Space to Start") / 2), 260, "Press Space to Start"
Text 128 - (StringWidth("High Score: " + GetScore$()) / 2), 1, "High Score: " + GetScore$()

Text 180, 300, "S)ound: " + bSfx

If KeyHit(31) Then
	If bSfx = True Then bSfx = False Else bSfx = True
EndIf

If KeyHit(59) = True Then 
	bCheat = True
	If bSfx = True Then PlaySound sfxEat ; Lives Cheat - F1
EndIf

If KeyHit(1) Then End

Flip: Cls
Until KeyHit(57)

Goto StepOver7

.NewLevel
oldScore = pScore
oldLives = pLives
bFresh = False

Delete Each Obj

.StepOver7

File = ReadFile("maze.txt")

; Read in power pellets
Repeat
	tmpX = Int(ReadLine(File))
	tmpY = Int(ReadLine(File))
	
	If tmpX >= 13 And tmpX <= 20 And tmpY >= 27 And tmpY <= 34 Then
	ElseIf tmpX >= 213 And tmpX <= 220 And tmpY >= 27 And tmpY <= 34 Then
	ElseIf tmpX >= 13 And tmpX <= 20 And tmpY >= 267 And tmpY <= 274 Then
	ElseIf tmpX >= 213 And tmpX <= 220 And tmpY >= 267 And tmpY <= 274 Then

	Else
		o.Obj = New Obj
		If tmpX > 117 Then o\X = tmpX - 3 Else o\X = tmpX - 4
		o\Y = tmpY - 3: o\ID = 1: o\A = True
		
	EndIf
	
Until Eof(File)
CloseFile File

; Create super pellets
o.Obj = New Obj
o\X = 13: o\Y = 27: o\ID = 4

o.Obj = New Obj
o\X = 13: o\Y = 267: o\ID = 4

o.Obj = New Obj
o\X = 213: o\Y = 267: o\ID = 4

o.Obj = New Obj
o\X = 213: o\Y = 27: o\ID = 4

Global pX# = 111, py# = 232, pT = MilliSecs(), pF = 5, pD = 0, pS# = 1, pDeath = False, pL, pStart = True, pKills = 0
Global bFruit = False, bSuper = False, superT, ghostT = MilliSecs(), ghostC = 0

If bFresh = False Then 
	pScore = oldScore 
	pLives = oldLives
Else 
	pScore = 0
	pLives = 2

	If bCheat = True Then pLives = 9 ; Lives cheat

EndIf

If bSfx = True Then PlaySound sfxStart

Origin 11, 0
While Not KeyDown(1)

DrawImage imgMaze, 0, 0, 1

; Objects
For o.Obj = Each Obj
	Select o\ID

		; Power pellet
		Case 1
		If o\A = True Then
			DrawImage imgDot, Int(o\X), Int(o\Y), 0
	
			If RectsOverlap(pX + 6, pY + 6, 4, 4, o\X, o\Y, 4, 4) Then
				o\A = False
				o\T = MilliSecs()
				
				pScore = pScore + 10
				If MilliSecs() >= sT + 450 Then
					If bSfx = True Then sfxChan = PlaySound(sfxWakka)
					sT = MilliSecs()
				EndIf
			EndIf
		
		Else
			If MilliSecs() >= o\T + 5000 And bFruit = False Then
				If Rand(1, 10000) = Rand(1, 10000) Then
					If Rand(1, 5) = 3 Then
						o\ID = 3: o\C = Rand(0, 6)
						bFruit = True
					EndIf
				EndIf
			EndIf
		EndIf
		
		; Rainbow Dust
		Case 2
		If o\C = 0 Then Color 87, 239, 255  ; Blue
		If o\C = 1 Then Color 233, 0, 35    ; Red
		If o\C = 2 Then Color 255, 119, 0   ; Orange
		If o\C = 3 Then Color 172, 254, 4   ; Green
		If o\C = 4 Then Color 255, 159, 255 ; Pink
		
		If o\I < .75 Then 
			Rect Int(o\X), Int(o\Y), 1, 1, 1
		Else
			Rect Int(o\X), Int(o\Y), 3, 1, 1
			Rect Int(o\X) + 1, Int(o\Y) - 1, 1, 3, 1
		EndIf
		
		If o\D = 0 Then o\X = o\X + o\I
		If o\D = 1 Then o\X = o\X - o\I
		If o\D = 3 Then o\Y = o\Y + o\I
		If o\D = 2 Then o\Y = o\Y - o\I
		
		o\I = o\I - .1
		If o\I <= 0 Then Delete o
		
		; Fruit
		Case 3
		DrawImage imgFruit, o\X - 3, o\Y - 3, o\C
		
		If ImageRectCollide(imgFruit, o\X - 3, o\Y - 3, o\C, pX + 6, pY + 6, 4, 4) Then
			pScore = pScore + 250

   		    If bSfx = True Then PlaySound sfxEat

			bFruit = False
			Delete o
		EndIf

		; Super pellet	
		Case 4
		DrawImage imgDot, o\X, o\Y, 1

		If ImageRectCollide(imgDot, o\X, o\Y, o\C, pX + 6, pY + 6, 4, 4) Then
			pScore = pScore + 100
			
			tmpX = o\X: tmpY = o\Y
			Delete o

			GhostsImmune		
			
			bSuper = True
			superT = MilliSecs()
			
			CreateParticles tmpX + 4, tmpY + 4, 2
			
			If bSfx = True Then PlaySound sfxSuper
			
			pKills = 0
		EndIf

		; Ghost
		Case 5
		
		oldX = o\X
		oldY = o\Y
		
		tmpS = 1
		
		If o\D = 1 Then 
			If o\Col[0] = 0 Then 
				If o\X < 232 Then o\X = o\X + tmpS Else o\X = -8
			EndIf
		EndIf
		
		If o\D = 0 Then 
			If o\Col[1] = 0 Then 
				If o\X > -8 Then o\X = o\X - tmpS Else o\X = 232
			EndIf
		EndIf
		
		If o\D = 2 Then 
			If o\Col[2] = 0 Then o\Y = o\Y + tmpS
		EndIf
		
		If o\D = 3 Then 
			If o\Col[3] = 0 Then o\Y = o\Y - tmpS
		EndIf

		;Rect o\X + 15, o\Y, 2, 15
		;Rect o\X - 1, o\Y, 2, 15
		;Rect o\X + 1, o\Y + 15, 14, 2
		;Rect o\X + 1, o\Y - 2, 14, 2
			
		tmp0 = o\Col[0]
		tmp1 = o\Col[1]
		tmp2 = o\Col[2]
		tmp3 = o\Col[3]
			
		o\Col[0] = 0
		o\Col[1] = 0
		o\Col[2] = 0
		o\Col[3] = 0
		
		stall = False
		If oldX = o\X And oldY = o\Y Then stall = True
		
		If ImageRectCollide(imgMaze, 0, 0, 1, o\X + 15, o\Y, 2, 15) Then 
			o\Col[0] = 1
		Else
			If tmp0 = 1 Or stall = True Then 
				If pX > o\X Then tmp1 = 2 Else tmp1 = 4
				If o\D <> 0 And Rand(1, tmp1) = 1 Then o\D = 1: Goto StepOver1
			;Else
			;	If pX > o\X Then o\D = 1
			EndIf
			
		EndIf
			
			
		If ImageRectCollide(imgMaze, 0, 0, 1, o\X - 1, o\Y, 2, 15) Then 
			o\Col[1] = 1
		Else
			If tmp1 = 1 Or stall = True Then 
				If pX < o\X Then tmp1 = 2 Else tmp1 = 4
				If o\D <> 1 And Rand(1, tmp1) = 1 Then o\D = 0:  Goto StepOver1
			;Else
			;	If pX < o\X Then o\D = 0
			EndIf
			
		EndIf
		
		If o\X >= 90 And o\X <= 144 And o\Y >= 85 And o\Y <= 103 Then
			; Dont reenter spawn area
		Else
		If ImageRectCollide(imgMaze, 0, 0, 1, o\X + 1, o\Y + 15, 14, 2) Then 
			o\Col[2] = 1
		Else
			If tmp2 = 1 Or stall = True Then 
				If pY > o\Y Then tmp1 = 2 Else tmp1 = 4
				If o\D <> 3 And Rand(1, tmp1) = 1 Then o\D = 2:  Goto StepOver1
			;Else
		;		If pY > o\Y Then o\D = 2
			EndIf
		EndIf
		EndIf
		
		If ImageRectCollide(imgMaze, 0, 0, 1, o\X + 1, o\Y - 2, 14, 2) Then 
			o\Col[3] = 1
		Else
			If tmp3 = 1 Or stall = True Then 
				If pY < o\Y Then tmp1 = 2 Else tmp1 = 4
				If o\D <> 2 And Rand(1, tmp1) = 1 Then o\D = 3: Goto StepOver1
			;Else
			;	If pY < o\Y Then o\D = 3
			EndIf
		EndIf

.StepOver1
		If bSuper = True And o\I = False Then
			If MilliSecs() >= superT + 4000 Then
				tmpF = MilliSecs() - (superT + 4000)
				If tmpF <= 500 Then tmpA = 1
				If tmpF > 500 And tmpF <= 1000 Then tmpA = 0
				If tmpF > 1000 And tmpF <= 1500 Then tmpA = 1
				If tmpF > 1500 And tmpF <= 2000 Then tmpA = 0
				If tmpF > 2000 And tmpF <= 2500 Then tmpA = 1
				If tmpF > 2500 And tmpF <= 3000 Then tmpA = 0
				
				DrawImage imgGhost, Int(o\X + 1), Int(o\Y + 1), 8 + (tmpA * 2)			
				
			Else
				tmpA = 0
				DrawImage imgGhost, Int(o\X + 1), Int(o\Y + 1), o\F + 8
			EndIf
		Else
			DrawImage imgGhost, Int(o\X + 1), Int(o\Y + 1), (o\C * 2) + o\F
		EndIf
		
		;SetFont Font2
		;Text o\X, o\Y - 8, o\I
		;SetFont Font
		
		If MilliSecs() >= o\T + 120 Then
			If o\F = 0 Then o\F = 1 Else o\F = 0
			
			o\T = MilliSecs()
		EndIf
		
		tmpD = 0
		If ImageRectCollide(imgGhost, o\X + 1, o\Y  + 1, 0, pX + 6, pY + 6, 4, 4) Then
			If bSuper = True And o\I = False Then

				pKills = pKills + 1
				
				If pKills = 1 Then pScore = pScore + 100
				If pKills = 2 Then pScore = pScore + 250
				If pKills = 3 Then pScore = pScore + 500
				If pKills = 4 Then pScore = pScore + 1000
							
				tmpX = o\X
				tmpY = o\Y
				
				o\I = True
				o\X = 110: o\Y = 114
				o\D = 3: o\T = MilliSecs()

				o\Col[0] = 0
				o\Col[1] = 0
				o\Col[2] = 0
				o\Col[3] = 0					
				
				CreateParticles tmpX + 7, tmpY + 7, tmpA
				CreateFloat tmpX + 7, tmpY + 7, pKills
				
				If bSfx = True Then PlaySound sfxEat
				
				tmpD = 1
			EndIf
		EndIf
		
		If o\I = True And tmpD = 0 And pDeath = False Then
			If ImageRectCollide(imgGhost, o\X + 1, o\Y  + 1, 0, pX + 2, pY + 2, 12, 12) Then
				pDeath = True
				pT = MilliSecs()
				pF = 0
				bSuper = False
				pL = 0
							
				If bSfx = True Then PlaySound sfxDeath
			EndIf
		EndIf
		
		;DebugLog o\D
		;If pX < o\X Then 
		;	If o\Col[0] = 0 Then o\D = 0
		;	
		;ElseIf pX > o\X Then
		;	If o\Col[1] = 0 Then o\D = 1	
		;EndIf
		
		;If pY > o\Y Then 
	;		If o\Col[2] = 0 Then o\D = 2
		;ElseIf pY < o\Y Then
		;	If o\Col[3] = 0 Then o\D = 3
		;EndIf
		
		; Particles
		Case 6
		
		If o\C = 0 Then Color 128, 128, 255   ; Blue
		If o\C = 1 Then Color 255, 255, 255 ; White
		If o\C = 2 Then Color 255, 255, 0 ; Yellow
	
		If o\I < 1 Then 
			Rect Cos(o\A) * o\R + Int(o\X), Sin(o\A) * o\R + Int(o\Y), 1, 1, 1
		Else
			Rect Cos(o\A) * o\R + Int(o\X), Sin(o\A) * o\R + Int(o\Y), 3, 1, 1
			Rect Cos(o\A) * o\R + Int(o\X) + 1, Sin(o\A) * o\R + Int(o\Y) - 1, 1, 3, 1
		EndIf
		
		o\R = o\R + o\I
		o\I = o\I - .1
		If o\I <= 0 Then Delete o

		; Floater
		Case 7	
				If pKills = 1 Then tmpS2$ = "100"
				If pKills = 2 Then tmpS2$ = "250"
				If pKills = 3 Then tmpS2$ = "500"
				If pKills = 4 Then tmpS2$ = "1000"
						
		SetFont Font2
		Color 255, 255, 255
		Text o\X - (StringWidth(tmpS2$) / 2), o\Y, tmpS2$
		
		If MilliSecs() >= o\T + 500 Then
			Delete o
		Else
			o\Y = o\Y - 1
		EndIf
			
		SetFont Font
								
	End Select
Next

If pStart = True Then 
	Text 256 / 2 - (StringWidth("START12") / 2), 135, "START"
	
	DrawImage imgPac, pX, pY, 5
	
	If MilliSecs() >= pT + 4500 Then pStart = False
	
	Goto StepOver2
EndIf

If bSuper = True Then
	; Rainbow dust
	o.Obj = New Obj
	If pD = 2 Or pD = 3 Then
		o\X = pX + Rand(2, 10)
	Else
		If pD = 1 Then o\X = pX + 6 Else o\X = pX + 10
	EndIf
	If pD = 0 Or pD = 1 Then
		o\Y = pY + Rand(4, 12)
	Else
		If pD = 2 Then o\Y = pY + 6 Else o\Y = pY + 10
	EndIf
	
	o\D = pD: o\ID = 2: o\C = Rand(0, 4): o\I# = Rnd(1, 2)
	
	If MilliSecs() >= superT + 7000 Then 
		bSuper = False
		GhostsImmune2
		
		
	EndIf
	
EndIf

; GHosts
If MilliSecs() >= ghostT + 1000 And ghostC <= 3 Then
	o.Obj = New Obj
	o\X = 110: o\Y = 114
	;o\X = 111: o\Y = 232
	o\ID = 5: o\C = ghostC: o\T = MilliSecs()
	o\D = 3
	o\I = True
	ghostC = ghostC + 1
	ghostT = MilliSecs()
EndIf

If pDeath = True Then
	If pF = 0 Then tmpF = 1
	If pF = 1 Then tmpF = 13
	If pF = 2 Then tmpF = 5
	If pF = 3 Then tmpF = 9
	
	DrawImage imgPac, pX, pY, tmpF
	
	If MilliSecs() >= pT + 100 Then
		If pF < 3 Then
			pF = pF + 1 
		Else
			If pL < 3 Then 
				pL = pL + 1
				pF = 0
			Else
				pDeath = False
				If pLives > 0 Then 
					pLives = pLives - 1 
					pX = 111: py = 232: pF = 0: pD = 0
					bFruit = False: bSuper = False: ghostT = MilliSecs(): ghostC = 0
					
					For o.Obj = Each Obj
						If o\ID = 5 Or o\ID = 3 Then Delete o
					Next
				
				Else 
					Goto GameOver
				EndIf
			EndIf
		EndIf
		
		pT = MilliSecs()
	EndIf
	
	Goto StepOver2
EndIf

If MilliSecs() >= pT + 75 Then
	If pF < 3 Then pF = pF + 1 Else pF = 0
	pT = MilliSecs()
EndIf

If pD = 1 Then 
	If pBR = 0 Then 
		If pX < 232 Then pX = pX + pS Else pX = -8
	EndIf
EndIf

If pD = 0 Then 
	If pBL = 0 Then 
		If pX > -8 Then pX = pX - pS Else pX = 232
	EndIf
EndIf

If pD = 2 Then 
	If pBD = 0 Then pY = pY + pS
EndIf

If pD = 3 Then 
	If pBU = 0 Then pY = pY - pS
	
EndIf


If KeyDown(203) Then 
	If pBL = 0 Then pD = 0
ElseIf KeyDown(205) Then
	If pBR = 0 Then pD = 1 
ElseIf KeyDown(208) Then 
	If PBD = 0 Then pD = 2
ElseIf KeyDown(200) Then
	If PBU = 0 Then pD = 3
EndIf

If pD = 0 Then 
	tmpF = 4 
Else If pD = 1 Then
	tmpF = 0
Else If pD = 3 Then
	tmpF = 8
Else If pD = 2 Then
	tmpF = 12
EndIf

DrawImage imgPac, pX, pY, pF + tmpF

Color 255, 0, 0
;Rect pX + 2, pY + 2, 12, 12

;Rect pX + 15, pY, 2, 15
;Rect pX - 1, pY, 2, 15
;Rect pX + 1, pY + 15, 14, 2
;Rect pX + 1, pY - 2, 14, 2

pBR = 0
pBL = 0
pBU = 0
pBD = 0

If ImageRectCollide(imgMaze, 0, 0, 1, pX + 15, pY, 2, 15) Then pBR = 1
If ImageRectCollide(imgMaze, 0, 0, 1, pX - 1, pY, 2, 15) Then pBL = 1
If ImageRectCollide(imgMaze, 0, 0, 1, pX + 1, pY + 15, 14, 2) Then pBD = 1
If ImageRectCollide(imgMaze, 0, 0, 1, pX + 1, pY - 2, 14, 2) Then pBU = 1

If pX >= 90 And pX <= 144 And pY >= 85 And pY <= 103 Then PBD = 1 ; Dont enter spawn area
		
.StepOver2
tmpX = 176
tmpY = 302
For i = 1 To pLives
	DrawImage imgPac, tmpX, tmpY, 1
	tmpX = tmpX + 18
Next

Color 0, 0, 0
Rect -11, 0, 16, 320, 1
Rect 229, 0, 16, 320, 1

Color 255, 255, 255
Text 1, 300, pScore

tmpC = False
For o.Obj = Each Obj
	If o\ID = 1 And o\A = True Then tmpC = True: Exit
	If o\ID = 4 Then tmpC = True: Exit
Next

If tmpC = False Then ; Win
	Goto NewLevel
EndIf

Goto StepOver3

.GameOver
WriteScore()

FlushKeys

Origin 0, 0
Repeat

Text 128 - (StringWidth("GAME OVER") / 2), 100, "GAME OVER"
Text 128 - (StringWidth("Press Any Key") / 2), 280, "Press Any Key"
Text 128 - (StringWidth("Final Score: " + pScore) / 2), 300, "High Score: " + pScore

Flip: Cls
Until GetKey() <> 0

Goto StartOver

.StepOver3

Flip: Cls
Wend: End

Function CreateParticles(tmpX, tmpY, tmpC)

For i = 0 To 15
	o.Obj = New Obj
	o\X = tmpX
	o\Y = tmpY
	o\C = tmpC
	o\A = Rand(0, 359)
	o\I = Rnd(2, 3)
	o\ID = 6
	
Next

End Function

Function GhostsImmune()
	For o.Obj = Each Obj
		If o\ID = 5 Then o\I = False
	Next
End Function
		
Function GhostsImmune2()
	For o.Obj = Each Obj
		If o\ID = 5 Then o\I = True
	Next
End Function
		
Function CreateFloat(tmpX, tmpY, tmpC)

	o.Obj = New Obj
	o\X = tmpX
	o\Y = tmpY - 8
	o\C = tmpC
	o\ID = 7
	o\T = MilliSecs()
	
End Function

Function GetScore$()

File = ReadFile("score.dat")

tmpS = ReadInt(File)

CloseFile File

Return tmpS

End Function


Function WriteScore()

File = ReadFile("score.dat")

tmpS = ReadInt(File)

CloseFile File

If pScore > tmpS Then
	File = WriteFile("score.dat")
	
	WriteInt File, pScore
	
	CloseFile File
EndIf

End Function